## ros-foxy-realtime-tools 2.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(realtime_tools)

if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

# Load catkin and all dependencies required for this package
find_package(ament_cmake REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_action REQUIRED)
find_package(Threads REQUIRED)

add_library(${PROJECT_NAME} src/realtime_clock.cpp)
ament_target_dependencies(${PROJECT_NAME} "rclcpp" "rclcpp_action")
target_link_libraries(${PROJECT_NAME} ${CMAKE_THREAD_LIBS_INIT})
target_include_directories(${PROJECT_NAME} PUBLIC include)

# Unit Tests
if(BUILD_TESTING)
  find_package(ament_cmake_cppcheck REQUIRED)
  find_package(ament_cmake_cpplint REQUIRED)
  find_package(ament_cmake_lint_cmake REQUIRED)
  find_package(ament_cmake_uncrustify REQUIRED)
  ament_cppcheck(LANGUAGE c++)
  ament_cpplint()
  ament_lint_cmake()
  ament_uncrustify(LANGUAGE C++)
  # Renable the below once we have a global variable
  # supporting the language feature for ament_uncrustify
  # find_package(ament_lint_auto REQUIRED)
  # set(ament_cmake_copyright_FOUND TRUE)
  # ament_lint_auto_find_test_dependencies()

  find_package(ament_cmake_gmock REQUIRED)
  find_package(test_msgs REQUIRED)

  ament_add_gmock(realtime_box_tests test/realtime_box_tests.cpp)
  target_link_libraries(realtime_box_tests ${PROJECT_NAME} ${GMOCK_MAIN_LIBRARIES})

  ament_add_gmock(realtime_buffer_tests test/realtime_buffer_tests.cpp)
  target_link_libraries(realtime_buffer_tests ${PROJECT_NAME} ${GMOCK_MAIN_LIBRARIES})

  ament_add_gmock(realtime_clock_tests test/realtime_clock_tests.cpp)
  target_link_libraries(realtime_clock_tests ${PROJECT_NAME} ${GMOCK_MAIN_LIBRARIES})

  ament_add_gmock(realtime_publisher_tests test/realtime_publisher.test test/realtime_publisher_tests.cpp)
  target_link_libraries(realtime_publisher_tests ${PROJECT_NAME} ${test_msgs_LIBRARIES} ${GMOCK_MAIN_LIBRARIES})
  target_include_directories(realtime_publisher_tests PRIVATE ${test_msgs_INCLUDE_DIRS})

  ament_add_gmock(realtime_server_goal_handle_tests test/realtime_server_goal_handle.test test/realtime_server_goal_handle_tests.cpp)
  target_link_libraries(realtime_server_goal_handle_tests ${PROJECT_NAME} ${test_msgs_LIBRARIES} ${GMOCK_MAIN_LIBRARIES})
  target_include_directories(realtime_server_goal_handle_tests PRIVATE ${test_msgs_INCLUDE_DIRS})
endif()

# Install
install(
  DIRECTORY include/
  DESTINATION include)

install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})

ament_export_dependencies(rclcpp)
ament_export_dependencies(rclcpp_action)

ament_package()

=== debian/changelog ===
ros-foxy-realtime-tools (2.2.0-1focal) focal; urgency=high

  * Adding new reset() function for Issue-247.
  * Contributors: bailaC

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 03 Nov 2021 00:00:00 -0000

ros-foxy-realtime-tools (2.1.1-1focal) focal; urgency=high

  * Fix deprecation warnings when constructing rclcpp::Duration
    Since https://github.com/ros2/rclcpp/pull/1432 (upcoming in Galactic), we should not initialize with a single integer
    as the units are ambiguous.
  * fix the mis-type error.
  * Fix uninitialized variable
  * Contributors: Jacob Perron, Victor Lopez, seanyen

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 21 Mar 2021 00:00:00 -0000

ros-foxy-realtime-tools (2.1.0-1focal) focal; urgency=high

  * fix msbuild warning
  * address linter failures
  * enable linters
  * avoid deprecations
  * Realtime server goal thread handle safety + additional warning fixes (#2 <https://github.com/ros-controls/realtime_tools/issues/2>) (#57 <https://github.com/ros-controls/realtime_tools/issues/57>)
    * Made code thread safe, fixed warnings with repeated aborts/success/cancels
    Fixed -reorder warning
    Early return
    * removed atomic
    * removed unneeded header
  * use template instead
  * use std::atomic instead of volatile
  * Contributors: Karsten Knese, Yutaka Kondo, ddengster

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 02 Jul 2020 23:00:00 -0000

ros-foxy-realtime-tools (2.0.0-1focal) focal; urgency=high

  * Add test_depend ament_cmake_gmock
  * Update CI for dashing
  * Add sloretz as another author
  * Typename and typos in RTPublisher
  * Shorter type names
  * Port RealtimeServerGoalHandle to ROS 2
  * Port RealtimePublisher to ROS 2
    Use test_msgs instead of std_msgs
  * Box and buffer work in ROS 2 unchanged
  * Port RealtimeClock to ROS 2
  * Remove actionlib definitions
  * Contributors: Shane Loretz

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 08 Sep 2019 23:00:00 -0000

ros-foxy-realtime-tools (1.14.0-1focal) focal; urgency=high

  * Undo action typedef changes
  * Remove boost
  * Clean up includes in realtime_tools namespace
  * Switch to gmock
  * Remove TARGET check on tests
  * Add unit test for RealtimeServerGoalHandle, RealtimePublisher, RealtimeClock, RealtimeBuffer, RealtimeBox
  * Fix race where first message won't get published
  * Clean up dependencies and package.xml
  * Contributors: Shane Loretz

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 21 Jul 2019 23:00:00 -0000

ros-foxy-realtime-tools (1.13.1-1focal) focal; urgency=high

  * Fix actionlib regression
  * Contributors: Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 14 Feb 2019 00:00:00 -0000

ros-foxy-realtime-tools (1.13.0-1focal) focal; urgency=high

  * Update readme
  * use this_thread::sleep_for instead of usleep (#32 <https://github.com/ros-controls/realtime_tools/issues/32>)
  * specify RUNTIME DESTINATION for libraries (#33 <https://github.com/ros-controls/realtime_tools/issues/33>)
    needed for exporting DLLs on Windows
  * Made RealtimeBuffer's copy-constructor const
  * Contributors: Bence Magyar, Gennaro Raiola, James Xu, Mathias Lüdtke, Matt Reynolds

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 11 Feb 2019 00:00:00 -0000

ros-foxy-realtime-tools (1.12.0-1focal) focal; urgency=high

  * Add RealtimePublisherSharedPtr<T>
  * boost::shared_ptr -> std::shared_ptr
  * Contributors: Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 18 May 2018 23:00:00 -0000

ros-foxy-realtime-tools (1.11.0-1focal) focal; urgency=high

  * Updated RT goal handle to handle cancel requests (#22 <https://github.com/ros-controls/realtime_tools/issues/22>)
  * switch to industrial_ci (#20 <https://github.com/ros-controls/realtime_tools/issues/20>)
  * Contributors: Mathias Lüdtke, Nick Lamprianidis

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 06 Nov 2017 00:00:00 -0000

ros-foxy-realtime-tools (1.10.0-1focal) focal; urgency=high

  * Added constructor in RTB for objects without default constructor
  * Add feedback sending capability to RealtimeServerGoalHandle.
  * Contributors: Bence Magyar, Aris Synodinos, Miguel Prada, graiola

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 27 Jun 2017 23:00:00 -0000

ros-foxy-realtime-tools (1.9.1-1focal) focal; urgency=high

  * RealtimeBox: Fix member doc
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Dave Coleman

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 29 Apr 2015 23:00:00 -0000

ros-foxy-realtime-tools (1.9.0-1focal) focal; urgency=high

  * Remove rosbuild artifacts.
  * Cleaned up CMake and removed unnecessary dependencies
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Dave Coleman

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 11 May 2014 23:00:00 -0000

ros-foxy-realtime-tools (1.8.3-1focal) focal; urgency=high

  * Fix linking
    The library needs to be linked against roscpp and Boost thread.
    GCC won't complain about missing symbols for a shared library,
    but other linkers (like clang's) will not accept it by default.
  * Added Travis support
  * Renamed manifest.xml so it doesn't brek rosdep
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Dave Coleman, Paul Mathieu

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 05 Feb 2014 00:00:00 -0000

ros-foxy-realtime-tools (1.8.2-1focal) focal; urgency=high

  * Append newline.
  * Merge pull request #4 <https://github.com/ros-controls/realtime_tools/issues/4> from pal-robotics/hydro-devel
    Add realtime action server goal handle.
  * Add realtime action server goal handle.
    - Factored out from PR2's implementation of the JointTrajectoryActionController.
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Austin Hendrix

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 28 Aug 2013 23:00:00 -0000

ros-foxy-realtime-tools (1.8.1-1focal) focal; urgency=high



=== debian/control ===
Source: ros-foxy-realtime-tools
Section: misc
Priority: optional
Maintainer: Bence Magyar <bence.magyar.robotics@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake, ros-foxy-ament-cmake-gmock, ros-foxy-ament-lint-auto, ros-foxy-ament-lint-common, ros-foxy-rclcpp, ros-foxy-rclcpp-action, ros-foxy-test-msgs, ros-foxy-ros-workspace
Homepage: http://ros.org/wiki/realtime_tools
Standards-Version: 3.9.2

Package: ros-foxy-realtime-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-ament-cmake, ros-foxy-rclcpp, ros-foxy-rclcpp-action, ros-foxy-ros-workspace
Description: Contains a set of tools that can be used from a hard realtime thread, without breaking the realtime behavior.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-realtime-tools//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
